    DECLARE SUB Pause (t#)
    DECLARE SUB load (x$)
    DECLARE SUB save (x$)

    '  Program for Texas Instruments 99/4a Computer to save & load
    '     By:  Kenneth Lantrip

    '  Requires ADVBAS Libraries

    '  To load first menu program onto TI type: OLD "SIO.BA=9600"
    '                                       or: OLD "RS232.BA=9600"

    DEFINT A-Z
    CLS : COLOR 14

    LOCATE 6, 12
    PRINT "Texas Instruments 99/4a disk drive interface is Operating."
'    CALL Pause(3): CLS

    OPEN "COM1:9600,N,8,1,RS,CS,DS,CD" FOR RANDOM AS #1 LEN = 516

    DO
        IF EOF(1) THEN
            PRINT #1, CHR$(22);
            CALL Pause(2): k$ = INKEY$
            IF k$ = " " THEN
                LOCATE 10, 5: INPUT "Enter Filename to Load -> ", com$
                com$ = LEFT$(com$ + "        ", 8)
            ELSE
                com$ = ""
            END IF
        ELSE
           IF LOC(1) > 8 THEN com$ = INPUT$(8, #1) ELSE com$ = INPUT$(LOC(1), #1)
        END IF
'        LOCATE 24, 1: PRINT : LOCATE 24, 1
'        IF LEN(com$) > 0 THEN PRINT "*"; ASC(com$); "*"
        IF com$ = CHR$(22) THEN CALL load("menu    ")

        IF com$ = "DIR" THEN
            LOCATE 6, 12
            PRINT "Texas Instruments 99/4a directory request is operating."
            PRINT : PRINT : PRINT
            SHELL "dir ti\*.ti  > tipgm.lst"
            OPEN "tipgm.lst" FOR INPUT AS #3
'            CALL Pause(.5)
            DO UNTIL EOF(3)
                LINE INPUT #3, z$
                CALL Pause(.25)
'                IF MID$(z$, 40, 1) = ":" THEN
                PRINT #1, z$: CALL Pause(.25)
            LOOP
            CLOSE #3: CLS : KILL "tipgm.lst"
        END IF

        i = LEN(com$)
        COLOR 8: LOCATE 1, 60: PRINT DATE$; "   "; TIME$: COLOR 14

        IF i = 8 THEN
            com$ = UCASE$(com$)
            FOR i = 1 TO 8
                IF INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789~`!@#$%&()-_' ", MID$(com$, i, 1)) = 0 THEN com$ = ""
            NEXT
            IF com$ > "" THEN CALL load(com$)
        END IF

        IF i = 4 THEN CALL save(com$)

    LOOP UNTIL k$ = CHR$(27)

    COLOR 7: PRINT " Program Terminated.  No Errors."
    CLOSE : END

SUB load (x$)

    x$ = "ti\" + RTRIM$(x$) + ".ti"
    CALL Exist(x$ + CHR$(0), s1%)
    IF s1% = 0 THEN EXIT SUB

    OPEN x$ FOR BINARY AS #2

    LOCATE 6, 11
    PRINT "Texas Instruments 99/4a load program from disk is Operating."

    IF x$ <> "ti\menu.ti" THEN
        DO
            IF NOT EOF(1) THEN t$ = INPUT$(LOC(1), #1) ELSE t$ = ""
        LOOP UNTIL t$ = CHR$(22)
    END IF

    DO
        PRINT #1, "x"; : CALL Pause(.1)
        IF NOT EOF(1) THEN t$ = INPUT$(LOC(1), #1) ELSE t$ = ""
    LOOP UNTIL t$ = CHR$(21)

    head$ = INPUT$(4, #2): i = 0
    PRINT #1, head$; : CALL Pause(.1)

    DO
        IF NOT EOF(1) THEN t$ = INPUT$(LOC(1), #1) ELSE t$ = ""
        IF t$ = CHR$(21) THEN PRINT #1, head$; : i = i + 1
        IF i > 9 THEN CLOSE #2: CLS : EXIT SUB
    LOOP UNTIL t$ = CHR$(6): i = 0

    DO UNTIL EOF(2)
        IF LOF(2) - LOC(2) > 129 THEN z$ = INPUT$(129, #2) ELSE z$ = INPUT$(1 + LOF(2) - LOC(2), #2)
        PRINT #1, z$;
        IF i AND 1 THEN
            CALL Pause(.1)
            DO
                IF NOT EOF(1) THEN t$ = INPUT$(LOC(1), #1) ELSE t$ = ""
            LOOP UNTIL t$ = CHR$(6) OR t$ = CHR$(21)
        END IF
        i = i + 1
    LOOP: CLOSE #2: CLS : x$ = ""

END SUB

SUB Pause (t#)

    x# = TIMER
    IF x# + t# > 86400# THEN
        x# = x# - 86400#
        DO
        LOOP UNTIL TIME$ = "0:00:00"
    END IF

    DO: LOOP UNTIL TIMER > x# + t#

END SUB

SUB save (x$)
    LOCATE 6, 12
    PRINT "Texas Instruments 99/4a save program to disk is Operating."

    n$ = "unknown.ti"
    OPEN "ti\titemp.sav" FOR OUTPUT AS #2

    PRINT #2, x$;
    PRINT #1, CHR$(6);
    CALL Pause(.1)
    x$ = "": f$ = ""

    DO UNTIL EOF(1)
        IF LOC(1) > 256 THEN
            y$ = INPUT$(256, #1)
            z$ = INPUT$(LOC(1), #1)
            PRINT #2, y$; z$;
        ELSE
            y$ = INPUT$(LOC(1), #1)
            z$ = ""
            PRINT #2, y$;
        END IF

        IF x$ > "" AND f$ = "" THEN
            q$ = RIGHT$(x$, 128) + LEFT$(y$, 128)
            ns = INSTR(q$, "--<")
            IF ns THEN
                IF ns < LEN(q$) - 12 AND MID$(q$, ns + 11, 3) = ">--" THEN f$ = MID$(q$, ns + 3, 8)
            END IF
        END IF
        IF f$ = "" THEN
            ns = INSTR(y$, "--<")
            IF ns THEN
                IF ns < LEN(y$) - 12 AND MID$(y$, ns + 11, 3) = ">--" THEN f$ = MID$(y$, ns + 3, 8)
            END IF
        END IF
        IF f$ = "" THEN x$ = y$

        PRINT #1, CHR$(6);
        CALL Pause(.35)
    LOOP
    CLOSE #2

    IF f$ > "" THEN n$ = RTRIM$(f$) + ".ti"
    n$ = "ti\" + n$
    CALL Exist(n$ + CHR$(0), ns)
    IF ns THEN KILL n$
    NAME "ti\titemp.sav" AS n$
    CLS : x$ = ""
   
END SUB

